typedef struct {
  const char *re;
  const char *str;
  const char *matches[5];
} TestItem;
static const TestItem tests[] = {
/* simple */
{"a(b)c", "abc", {"abc", "b", "", "", ""}},
{"a((b)(c))", "abc", {"abc", "bc", "b", "c", ""}},
{"a((((b))))c", "abc", {"abc", "b", "b", "b", "b"}},
{"a((((b))))c", "a(b)c", {"", "", "", "", ""}},
{"a\\(", "a(", {"a(", "", "", "", ""}},
{"a()b", "ab", {"ab", "", "", "", ""}},
{"a()()b", "ab", {"ab", "", "", "", ""}},
{"(we|wee|week|frob)(knights|night|day)", "weeknights", {"weeknights", "wee", "knights", "", ""}},
{"aa|(bb)|cc", "aabb", {"aa", "", "", "", ""}},
{"aa|(bb)|cc", "abbaa", {"bb", "bb", "", "", ""}},
{"aa|(bb)|cc", "bccaa", {"cc", "", "", "", ""}},
{"aa|a(b)|cc", "abaab", {"ab", "b", "", "", ""}},
{"aa|a(b)", "abaab", {"ab", "b", "", "", ""}},
{"aa|(a(b))|cc", "abaabcc", {"ab", "ab", "b", "", ""}},
{"(ab)|ac", "aaaabcc", {"ab", "ab", "", "", ""}},
{"(a(b))|ac", "abaabcc", {"ab", "ab", "b", "", ""}},
{"ab|(ac)", "aaaabcc", {"ab", "", "", "", ""}},
{"ab|(ac)", "aaaacbc", {"ac", "ac", "", "", ""}},
{"aa|(ab|(ac))|ad", "cac", {"ac", "ac", "ac", "", ""}},
{"(aa|(a(b)|a(c))|ad)", "cac", {"ac", "ac", "ac", "", "c"}},
{"(.)*", "abc", {"abc", "c", "", "", ""}},
{"b|()|a", "cac", {"", "", "", "", ""}},
/* simple meta */
{"a.c", "abc", {"abc", "", "", "", ""}},
{"a..", "abc", {"abc", "", "", "", ""}},
{"a..", "ab", {"", "", "", "", ""}},
{"...", "ab", {"", "", "", "", ""}},
{".", "abc", {"a", "", "", "", ""}},
{".", "", {"", "", "", "", ""}},
/* anchors */
{"^abc", "abcd", {"abc", "", "", "", ""}},
{"^abc", "aabcd", {"", "", "", "", ""}},
{"^abc|def", "abc", {"abc", "", "", "", ""}},
{"^abc|def", "zabc", {"", "", "", "", ""}},
{"^abc|def", "zabcdef", {"def", "", "", "", ""}},
{"abc|^def", "defabc", {"def", "", "", "", ""}},
{"abc|^def", "abcdef", {"abc", "", "", "", ""}},
{"abc|^def", "defabbc", {"def", "", "", "", ""}},
{"abc|^def", "adefbc", {"", "", "", "", ""}},
{"^(abc|def)", "abc", {"abc", "abc", "", "", ""}},
{"^(abc|def)", "aabc", {"", "", "", "", ""}},
{"(^abc|def)", "abcdef", {"abc", "abc", "", "", ""}},
{"(^abc|def)", "^abcdef", {"def", "def", "", "", ""}},
{"^", "hoge", {"", "", "", "", ""}},
{"$", "hoge", {"", "", "", "", ""}},
{"abc$", "bcabc", {"abc", "", "", "", ""}},
{"abc$", "abcab", {"", "", "", "", ""}},
{"^abc$", "abc", {"abc", "", "", "", ""}},
{"^$", "", {"", "", "", "", ""}},
{"^$", "a", {"", "", "", "", ""}},
{"abc$|def", "abc", {"abc", "", "", "", ""}},
{"abc$|def", "defabc", {"def", "", "", "", ""}},
{"^abc|def$", "abcdef", {"abc", "", "", "", ""}},
{"^abc|def$", "defabc", {"", "", "", "", ""}},
{"^abc|def$", "defabc", {"", "", "", "", ""}},
{"(^abc|def$)", "aaadef", {"def", "def", "", "", ""}},
{"ab\\$", "ab$cd", {"ab$", "", "", "", ""}},
/* backslash escape */
{"a\\*c", "a*c", {"a*c", "", "", "", ""}},
{"a\\.c", "a.c", {"a.c", "", "", "", ""}},
{"a\\.c", "abc", {"", "", "", "", ""}},
{"a\\\\b", "a\\b", {"a\\b", "", "", "", ""}},
{"a\\\\\\*b", "a\\*b", {"a\\*b", "", "", "", ""}},
{"a\\\\bc", "a\\bc", {"a\\bc", "", "", "", ""}},
{"a\\[b", "a[b", {"a[b", "", "", "", ""}},
/* repetitions */
{"ab*c", "abc", {"abc", "", "", "", ""}},
{"ab*c", "ac", {"ac", "", "", "", ""}},
{"ab*c", "abbbc", {"abbbc", "", "", "", ""}},
{"ab*c", "abbabaabbc", {"abbc", "", "", "", ""}},
{"ab+c", "abc", {"abc", "", "", "", ""}},
{"ab+c", "abbc", {"abbc", "", "", "", ""}},
{"ab+c", "abbabaabbc", {"abbc", "", "", "", ""}},
{"ab?c", "abc", {"abc", "", "", "", ""}},
{"ab?c", "abbaac", {"ac", "", "", "", ""}},
{"a.*c", "abc", {"abc", "", "", "", ""}},
{"a.*c", "zaabcabcabcabcczab", {"aabcabcabcabcc", "", "", "", ""}},
{"a(b*|c)d", "abbd", {"abbd", "bb", "", "", ""}},
{"a(b*|c)d", "ad", {"ad", "", "", "", ""}},
{"a(b*|c)d", "acd", {"acd", "c", "", "", ""}},
{"a(b*|c)d", "abcd", {"", "", "", "", ""}},
{"a.*c", "bacbababbbbadbaba", {"ac", "", "", "", ""}},
{"a.*c", "abaaaabababbadbabdba", {"", "", "", "", ""}},
/* repetitions (non-greedy) */
{"ab*?.", "abc", {"ab", "", "", "", ""}},
{"ab*?.", "ac", {"ac", "", "", "", ""}},
{"a.*?c", "abbbc", {"abbbc", "", "", "", ""}},
{"a.*?a", "abbabaabbc", {"abba", "", "", "", ""}},
{"<.*?>", "<tag1><tag2><tag3>", {"<tag1>", "", "", "", ""}},
{"ab+?.", "abc", {"abc", "", "", "", ""}},
{"ab+?.", "abbc", {"abb", "", "", "", ""}},
{"a.+?a", "abbabaabbc", {"abba", "", "", "", ""}},
{"<.+?>", " <><tag1><tag2>", {"<><tag1>", "", "", "", ""}},
{"ab??c", "abc", {"abc", "", "", "", ""}},
{"ab??c", "abbaac", {"ac", "", "", "", ""}},
{"ab??.", "abbaac", {"ab", "", "", "", ""}},
{"a(hoge)??hoge", "ahogehoge", {"ahoge", "", "", "", ""}},
{"(foo)??bar", "foobar", {"foobar", "foo", "", "", ""}},
{"(foo)??bar", "foofoobar", {"foobar", "foo", "", "", ""}},
{"(foo)*?bar", "foofoobar", {"foofoobar", "foo", "", "", ""}},
/* uncapturing group */
{"a(?:b)*c(d)", "abcdbcdefg", {NULL, "d", NULL, NULL, NULL}},
{"a(?:bcd)*e(f)", "abcdbcdefg", {NULL, "f", NULL, NULL, NULL}},
{"a(?:bcd)*e(f)", "aefg", {NULL, "f", NULL, NULL, NULL}},
{"a(?:bcd)+e(f)", "aefg", {NULL, "", NULL, NULL, NULL}},
{"a(?:bc(de(?:fg)?hi)jk)?l", "abcdefghijkl", {NULL, "defghi", NULL, NULL, NULL}},
{"a(?:bc(de(?:fg)?hi)jk)?l", "abcdehijkl", {NULL, "dehi", NULL, NULL, NULL}},
{NULL, NULL, {NULL, NULL, NULL, NULL, NULL}}
};
